$(function() {

    $('[data-gmap]').each(function() {

        var $base = $(this);

        var options = $base.data('gmap');

        if (typeof options == 'string') {
            options = {address: options};
        } else if (typeof options != 'object') {
            options = {};
        }

        $.each(this.attributes, function() {
            if (this.name.substr(0,5) === 'data-') {
                var k = this.name.substr(5);
                if (k !== 'gmap') {
                    options[k] = $base.data(k);
                }
            }
        });

        if (!options.hasOwnProperty('lng') && options.hasOwnProperty('lon')) {
            options.lng = options.lon;
        }

        var settings = $.extend({}, options);

        settings.div = $base.get(0);
        var map = new GMaps(settings);

        if (settings.hasOwnProperty('address')) {

            GMaps.geocode({
                address: settings.address,
                callback: function(results, status) {
                    if (status == 'OK') {
                        var latlng = results[0].geometry.location;
                        if (!settings.hasOwnProperty('lat') && !settings.hasOwnProperty('lon')) {
                            map.setCenter(latlng.lat(), latlng.lng());
                            map.addMarker({
                                lat: latlng.lat(),
                                lng: latlng.lng()
                            });
                            // todo update latlng with ajax to data
                        }
                    }
                }
            });
        }

        $base.data('gmap', map);

    });

});